﻿program AYACLOCK;

uses
  FastMM4,
  sysutils,
  windows,
  Forms,
  ayaclkf in 'ayaclkf.pas' {AyaClockForm},
  aboutf in 'aboutf.pas' {AboutForm},
  acpostfix in 'acpostfix.pas',
  GETOSINF in '..\dlib\d10\utils\GETOSINF.PAS',
  Vcl.Themes,
  Vcl.Styles;

{$R *.RES}

var
  hMutex : THandle;
  sts : DWORD;

// {$R ayaclock_jp_res.res}

begin
  {$IFDEF DEBUG}
  ReportMemoryLeaksOnShutdown := True;
  {$ENDIF}
  // OS version check
  if not IsWin10AUOrLater then begin
    Windows.MessageBox(0,PChar('need Windows 10 Anniversary Update or later'),'AyaClock '+postfix,MB_OK OR MB_ICONERROR);
    Exit;
  end;

  // 二重起動の防止
  hMutex:=CreateMutex(nil,TRUE,'AyaClockMutex2000');
  sts:=GetLastError;
  CASE sts OF
    NO_ERROR:
      BEGIN
        // 作成できたので実行！
        try
          Application.Initialize;
          Application.MainFormOnTaskbar := True;
          Application.CreateForm(TAyaClockForm, AyaClockForm);
  Application.Run;
        finally
          CloseHandle(hMutex);
        end;
      END;
    ERROR_ALREADY_EXISTS:
      CloseHandle(hMutex);  // 既に起動しているので閉じて終わる
    ELSE
      // 一応
      windows.MessageBox(0,PChar('Err Code : '+IntToStr(sts)),'AyaClock '+postfix,MB_OK OR MB_ICONERROR);
  END;
end.
