﻿unit aboutf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, formutils, pngimage, acpostfix, HighDPIAPIs,
  Winapi.Multimon;

const
  WM_FIRSTSHOW = WM_APP + $500;

type
  TAboutForm = class(TForm)
    Bevel1: TBevel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 宣言 }
    FirstShow : boolean;
    procedure WmFirstShow(var AMsg:TMessage); message WM_FIRSTSHOW;
    procedure WmDPIChanged(var AMsg:TWMDPICHANGED); message WM_DPICHANGED;
  public
    { Public 宣言 }
  end;

implementation

{$R *.DFM}

uses
  getosinf;

procedure TAboutForm.FormCreate(Sender: TObject);
begin
  FirstShow:=true;
  Label1.Caption:='AyaClock '+postfix+' '+Label1.Caption;
{$IFDEF DEBUG}
  Caption:=Caption+'(debug mode)';
{$ENDIF}
end;

procedure TAboutForm.FormShow(Sender: TObject);
begin
  if FirstShow then begin
    FirstShow:=false;
    PostMessage(handle,WM_FIRSTSHOW,0,0);
  end;
end;

procedure TAboutForm.WmFirstShow(var AMsg: TMessage);
var
  m : TMonitor;
  w,xdpi,ydpi:UINT;
  _hdc : HDC;
begin
  _HDC:=GetDC(0);
  try
    xdpi:=GetDeviceCaps(_hdc,LOGPIXELSX);
  finally
    ReleaseDC(0,_HDC);
  end;
  if IsWin81OrLater then begin
    m:=Screen.MonitorFromWindow(handle);
    if s_ok=GetDPIForMonitor(m.Handle,MDT_Effective_DPI,w,ydpi) then
      xdpi:=w;
  end;
  PixelsPerInch:=xdpi;
  AdjustFormPosWithMM(self,true);
end;

procedure TAboutForm.WmDPIChanged(var AMsg:TWMDPICHANGED);
begin
  PixelsPerInch:=AMsg.XDPI;
  AdjustFormPosWithMM(self,true);
end;

end.
