unit adminutils;

/////////////////////////////////////////////////////////////////////////////
//
// adminǂ𔻒肷
// Q : http://sysneitf.ifdef.jp/system_isadmin.html
// ڐA : fT
//
// date : 2009/08/08
// memo : o
//
// date : 2009/08/11
// memo : IsUserAnAdminAGetElevationTypeǉ
//
/////////////////////////////////////////////////////////////////////////////

interface

uses
  Winapi.windows;

function IsAdmin:boolean;
function IsUserAnAdmin:boolean;
function GetElevationType(var AnElevationType:TTokenElevationType):boolean;

implementation

uses
  System.sysutils;

const
  SECURITY_NT_AUTHORITY : TSIDIdentifierAuthority = (value:(0,0,0,0,0,5));
  SECURITY_BUILTIN_DOMAIN_RID = $00000020;
  DOMAIN_ALIAS_RID_ADMINS     = $00000220;
  MAX_NAME_SIZE = 1024;

function IsAdmin:boolean;
var
  hToken : THandle;
  dwSize,dwBuf,i,GroupCount : DWORD;
  ok :boolean;
  pGroupInfo : pointer;
  SIDAuth : TSIDIdentifierAuthority;
  sidBuf : PSID; // same as Pointer
  name,domain : array[0..MAX_NAME_SIZE-1] of Char;
  pSIDAndAttr : PSIDAndAttributes;
  sidNameUse : SID_NAME_USE;
begin
  result:=false;
  //
  if NOT OpenProcessToken(GetCurrentProcess,TOKEN_QUERY,hToken) then exit;
  try
    dwSize:=0; dwBuf:=0;
    if GetTokenInformation(hToken,TokenGroups,nil,dwBuf,dwSize) then
      ok:=true
    else
      ok:=(GetLastError=ERROR_INSUFFICIENT_BUFFER);
    //
    if ok then begin
      try
        pGroupInfo:=AllocMem(dwSize);
        try
          if GetTokenInformation(hToken,TokenGroups,pGroupInfo,dwSize,dwSize) then begin
            SIDAuth:=SECURITY_NT_AUTHORITY;
            if AllocateAndInitializeSid(SIDAuth,2,SECURITY_BUILTIN_DOMAIN_RID,
                                        DOMAIN_ALIAS_RID_ADMINS,0,0,0,0,0,0,sidBuf) then begin
              try
                GroupCount:=PTokenGroups(pGroupInfo)^.GroupCount;
                pSIDAndAttr:=@(PTokenGroups(pGroupInfo)^.Groups[0]); i:=0;
                REPEAT
                  if EqualSid(sidBuf,pSIDAndAttr^.Sid) then begin
                    dwSize:=MAX_NAME_SIZE;
                    if LookupAccountSid(nil,pSIDAndAttr^.Sid,@name[0],dwSize,@domain[0],dwSize,sidNameUse) then begin
                      result:=(domain='BUILTIN') AND (name='Administrators');
                      if result then break;
                    end else
                      break;
                  end;
                  Inc(i); Inc(pSIDAndAttr);
                UNTIL i>=GroupCount;
              finally
                FreeSid(sidBuf);
              end;
            end;
          end;
        finally
          FreeMem(pGroupInfo);
        end;
      except
        on EOutOfMemory do ;
      end;
    end;
  finally
    CloseHandle( hToken );
  end;
end;

function GetElevationType(var AnElevationType:TTokenElevationType):boolean;
var
  hProcToken : THANDLE;
  dwSize : DWORD;
begin
  result:=false;
  if NOT OpenProcessToken(GetCurrentProcess,TOKEN_QUERY,hProcToken) then exit;
  try
    result:=GetTokenInformation(hProcToken,TokenElevationType, @AnElevationType, sizeof(TTokenElevationType), dwSize);
  finally
    CloseHandle(hProcToken);
  end;
end;

var
  hShell32:THandle;
  _IsUserAnAdmin : function:BOOL; stdcall;

function IsUserAnAdmin:boolean;
begin
  if @_IsUserAnAdmin=nil then
    result:=true
  else
    result:=_IsUserAnAdmin;
end;

procedure Init;
var
  sv : integer;
  p  : TFarProc;
begin
  @_IsUserAnAdmin:=nil;
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    hShell32:=LoadLibrary('shell32.dll');
    if hSHell32<>0 then begin
      if (Win32MajorVersion=5) and (Win32MinorVersion=0) then
        // w2kł͏łexport
        p:=GetProcAddress(hShell32,MAKEINTRESOURCE(680))
      else
        // xpȍ~ł̓V{export
        p:=GetProcAddress(hShell32,'IsUserAnAdmin');
      if p<>nil then @_IsUserAnAdmin:=p;
    end;
  finally
    SetErrorMode(sv);
  end;
end;

procedure Done;
begin
  if hShell32<>0 then begin
    @_IsUserAnAdmin:=nil;
    FreeLibrary(hShell32);
    hShell32:=0;
  end;
end;

initialization
  Init;

finalization
  Done;

end.
