﻿unit ayaclkf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Registry,ShellApi,
  aboutf, XPMan, Adminutils, ImgList, Getosinf, privilegesutils, highdpiapis,
  WindowsDarkMode,
  System.ImageList;

type
  TShowMemType = ( smtKB, smtMB, smtGB );
  TColorType = (ctDefault, ctTheme);

  TAyaClockForm = class(TForm)
    BasePnl: TPanel;
    Timer1: TTimer;
    TimeST: TStaticText;
    MemST: TStaticText;
    Pmn: TPopupMenu;
    mnQuit: TMenuItem;
    mnDmy0: TMenuItem;
    mnFont: TMenuItem;
    mnPosition: TMenuItem;
    mnAbout: TMenuItem;
    mnLeftTop: TMenuItem;
    mnLeftBottom: TMenuItem;
    mnRightTop: TMenuItem;
    mnRightBottom: TMenuItem;
    FontDlg: TFontDialog;
    mnDmy2: TMenuItem;
    mnAnyPos: TMenuItem;
    LB: TLabel;
    DayST: TStaticText;
    cLB: TLabel;
    Shape1: TShape;
    mnIgnoreTB: TMenuItem;
    mnAdjustTime: TMenuItem;
    mnAlwaysTop: TMenuItem;
    mnComma: TMenuItem;
    mnSecond: TMenuItem;
    TrayIcon: TTrayIcon;
    mnWeekday: TMenuItem;
    mnWDEn3: TMenuItem;
    mnWDEn2: TMenuItem;
    mnWDKanji: TMenuItem;
    mnWDNone: TMenuItem;
    mnDmy1: TMenuItem;
    mnMemory: TMenuItem;
    mnKB: TMenuItem;
    mnMB: TMenuItem;
    N1: TMenuItem;
    ImgLst: TImageList;
    mnGB: TMenuItem;
    mnColor: TMenuItem;
    mnDefaultColor: TMenuItem;
    mnThemeColor: TMenuItem;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnQuitClick(Sender: TObject);
    procedure mnFontClick(Sender: TObject);
    procedure mnAboutClick(Sender: TObject);
    procedure mnPosChangeClick(Sender: TObject);
    procedure ACMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ACSTMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ACSTMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnIgnoreTBClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnAdjustTimeClick(Sender: TObject);
    procedure PmnPopup(Sender: TObject);
    procedure TrayIconClick(Sender: TObject);
    procedure mnAlwaysTopClick(Sender: TObject);
    procedure mnCommaClick(Sender: TObject);
    procedure mnSecondClick(Sender: TObject);
    procedure mnWeekdayClick(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnMemUnitsClick(Sender: TObject);
    procedure mnDefaultColorClick(Sender: TObject);
    procedure mnThemeColorClick(Sender: TObject);
  private
    { Private 宣言 }
  protected
    { protected 宣言 }
    FShowMemType : TShowMemType;
    preMinSec,
    sx,sy,PosType : integer;
    WeekdayType : integer;
    Weekday,
    FNowOp,
    NowMoving : boolean;
    qCounter : DWORD;
    newDPI : UInt;
    dpichecked : boolean;
    OrgFontSize : integer;
    FColorType : TColorType;
    procedure SetupTimeAndMem;
    procedure SetPos;
    procedure ResetPosition(newpos:integer);
    procedure Adjust;
    procedure AdjustForDPIChanged(ADPI:UInt);
    procedure ChangeFormXY(C:TCOntrol; var x,y:integer);
    procedure LoadReg;
    procedure SetNowOp(ANowOp:boolean);
    function  GetStayOnTop:boolean;
    procedure SetStayOnTop(AValue:boolean);
    function  GetComma:boolean;
    procedure SetComma(AValue:boolean);
    function  GetSecond:boolean;
    procedure SetSecond(AValue:boolean);
    procedure CreateParams(var Params: TCreateParams); override;
    function  MemModifier:int64;
    function  MemUnitString:string;
    procedure SetShowMemType(AMemType:TShowMemType);
    function  GetMaxPhysMemStr:string;
    procedure GetShieldIcon;
    procedure WmQueryEndSession(var msg:TWMQueryEndSession); message WM_QUERYENDSESSION;
    // win 8.1 or later, FormCreateより前にメッセージがくる!
    procedure WmDPIChanged(var msg:TWMDPIChanged); message WM_DPICHANGED;
    procedure WMSettingChange(var Message: TWMSettingChange); message WM_SETTINGCHANGE;
    function  GetCurrentDPI:Uint;
    procedure HandleThemes;
    procedure UnHandleThemes;
    procedure SetColorType(value:TColorType);
  public
    { Public 宣言 }
    constructor Create(AOwner:TComponent); override;
    property  NowOp : boolean read FNowOp write SetNowOp;
    property  StayOnTop : boolean read GetStayOnTop write SetStayOnTop;
    property  Comma : boolean read GetComma write SetComma;
    property  Second : boolean read GetSecond write SetSecond;
    property  ShowMemType : TShowMemType read FShowMemType write SetShowMemType;
    property  MaxPhysMemStr : string read GetMaxPhysMemStr;
    property  ColorType : TColorType read FColorType write SetColorType;
  end;

var
  AyaClockForm: TAyaClockForm;

implementation

{$R *.DFM}

const
  defPosType = 1; // 左上
  RegRoot = 'Software\MarleySoft\AyaClock';
  SecPosition = 'Position';
  KeyType = 'Type';
  defType = defPosType;
  KeyX = 'X';
  defX = 0;
  KeyY = 'Y';
  defY = 0;
  SecFont = 'Font';
  KeyName = 'Name';
  defName = 'ＭＳ Ｐゴシック';
  KeySize = 'Size';
  defSize = 9;
  KeyEffect = 'Effect';
  defEffect = 0;
  feBold = $01; feItalic = $02; feUnderLine = $04; feStrikeOut = $08;
  KeyColor = 'Color';
  defColorVal = clWindowText;
  SecOption = 'Option';
  KeyIgnoreTaskBar = 'IgnoreTaskBar';
  defIgnoreTaskBar = FALSE;
  KeyAlwaysTop = 'AlwaysTop';
  defAlwaysTop = FALSE;
  KeyComma = 'Comma';
  defComma = false;
  KeySecond = 'Second';
  defSecond = false;
  KeyWeekday = 'Weekday';
  defWeekday = false;
  KeyWeekdayType = 'WeekdayType';
  defWeekdayType = 0;
  KeyShowMemType = 'MemType';
  defShowMemType = 0;
  SecColor = 'Color';
  KeyColorType = 'ColorType';
  defColorType = ctDefault;

  NoRequestDPIChanged = 0;
  DefDPI = 96;

  WeekdayStrs : array[0..2,0..6] of string = (('Sun','Mon','Tue','Wed','Thu','Fri','Sat'),
                                              ('Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'),
                                              ('日', '月', '火', '水', '木', '金', '土'));

function Zeller:integer;
var
  y,m,d : integer;
  dt : TDateTime;
begin
  dt:=Now;
  y:=StrToInt(FormatDateTime('yyyy',dt));
  m:=StrToInt(FormatDateTime('m',dt));
  d:=StrToInt(FormatDateTime('d',dt));
  case m of
    1 : begin
          y:=y-1; m:=13;
        end;
    2 : begin
          y:=y-1; m:=14;
        end;
  end;
  result:=(y+(y div 4)-(y div 100)+(y div 400) +((m*13+8) div 5) +d) mod 7;
end;

function IntToCommaStr(AInt:int64; AKeta:integer):string;
var
  work,minus:string;
  i,L : integer;
begin
  // まずは普通に変換
  result:=IntToStr(AInt);
  IF AKeta<2 THEN Exit;
  work:='';
  L:=Length(result);
  // マイナス値だったときの対策!!
  minus:='';
  IF result[1]='-' THEN BEGIN
    minus:='-'; result:=Copy(result,2,L-1);
  END;
  // Keta
  FOR i:=L DOWNTO 1 DO BEGIN
    work:=result[i]+work;
    IF (((L-i+1) mod AKeta)=0) AND (i<>1) THEN work:=FormatSettings.ThousandSeparator+work;
  END;
  result:=minus+work;
end;

constructor TAyaClockForm.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  // デフォルト設定
  PosType:=defPosType; NowMoving:=false;
  qCounter:=0;
  FNowOp:=false;
  FShowMemType:=smtKB;
  preMinSec := -1;
  FColorType := defColorType;
  // DPI changed
  dpichecked:=false;
  newDPI:=NoRequestDPIChanged;
end;

procedure TAyaClockForm.FormCreate(Sender: TObject);
begin
  // check DPI if needed (Win8 and brefore)
  if NOT dpichecked then PixelsPerInch:=GetCurrentDPI;
  // read reg
  LoadReg;
  // 調整
  Adjust;
  ResetPosition(PosType);
  //
  SetupTimeAndMem;
end;

procedure TAyaClockForm.HandleThemes;
begin
  mnThemeColor.Checked := true;
  SetAppropriateThemeMode('Windows10 Dark', 'Windows10');
end;

procedure TAyaClockForm.UnHandleThemes;
begin
  mnDefaultColor.Checked:=true;
  SetAppropriateThemeMode('Windows','Windows');
end;

procedure TAyaClockForm.SetColorType(value:TColorType);
var
  ini : TRegIniFile;
begin
  if value=ColorType then Exit;
  //
  FColorType := value;
  case FColorType of
    ctDefault: UnHandleThemes;
    ctTheme: HandleThemes
  end;
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteInteger(SecColor,KeyColorType,Ord(ColorTYpe));
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.WMSettingChange(var Message: TWMSettingChange);
begin
  if (ColorType=ctTheme) and SameText('ImmersiveColorSet', String(Message.Section)) then
    HandleThemes;
end;

procedure TAyaClockForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle:=WS_EX_TOOLWINDOW;
end;

procedure TAyaClockForm.GetShieldIcon;
var
  icn : TIcon;
  stockIcon : SHSTOCKICONINFO;
  s : TBitmap;
begin
  if NOT CheckWin32Version(6,0) then exit;
  if mnAdjustTime.ImageIndex<>-1 then Exit;
  //
  stockIcon.cbSize:=sizeof(stockIcon);
  if S_OK=SHGetStockIconInfo(SIID_SHIELD, SHGSI_ICON OR SHGSI_SMALLICON, stockIcon) then begin
    icn:=TIcon.Create;
    try
      icn.Handle:=stockIcon.hIcon;
      if CheckWin32Version(6,2) then begin
        // for windows8
        s:=TBitmap.Create;
        try
          icn.assignto(s);
          mnAdjustTime.ImageIndex:=ImgLst.AddMasked(s,s.canvas.Pixels[0,0]);
          ImgLst.ShareImages:=false; // free bitmap handle when ImgLst disposed
        finally
          s.ReleaseHandle;
          s.free;
        end;
      end else
        // for windows7 and before
        mnAdjustTime.ImageIndex:=ImgLst.AddIcon(icn);
    finally
      icn.ReleaseHandle;
      icn.Free;
    end;
  end;
end;

procedure TAyaClockForm.LoadReg;
var
  ini : TRegIniFile;
  w : integer;
begin
  ini:=TRegIniFile.Create(RegRoot);
  try
    mnIgnoreTB.Checked:=ini.ReadBool(SecOption,KeyIgnoreTaskBar,defIgnoreTaskBar);
    PosType:=ini.ReadInteger(SecPosition,KeyType,defType);
    IF (PosType<1) OR (PosType>5) THEN PosType:=1;
    CASE PosType OF
      2 : mnLeftBottom.Checked:=true;
      3 : mnRightTop.Checked:=true;
      4 : mnRightBottom.Checked:=true;
      5 : mnAnyPos.Checked:=true;
    END;
    left:=ini.ReadInteger(SecPosition,KeyX,defX);
    top:=ini.ReadInteger(SecPosition,KeyY,defY);
    Font.Name:=ini.ReadString(SecFont,KeyName,defName);
    OrgFontSize:=ini.ReadInteger(SecFont,KeySize,defSize);  // for Hi DPI and DPI changed
    Font.Size:=OrgFontSize * PixelsPerInch div DefDPI;
    Font.Color:=StringToColor(Ini.ReadString(SecFont,KeyColor,ColorToString(defColorVal)));
    Font.Style:=[];
    w:=ini.ReadInteger(SecFont,KeyEffect,defEffect);
    IF (w AND feBold)<>0 THEN Font.Style:=Font.Style+[fsBold];
    IF (w AND feItalic)<>0 THEN Font.Style:=Font.Style+[fsItalic];
    IF (w AND feUnderLine)<>0 THEN Font.Style:=Font.Style+[fsUnderLine];
    IF (w AND feStrikeOut)<>0 THEN Font.Style:=Font.Style+[fsStrikeOut];
    ColorType:=TColorType(ini.ReadInteger(SecColor,KeyColorType,Ord(defColorType)));
    StayOnTop:=ini.ReadBool(SecOption,KeyAlwaysTop,defAlwaysTop);
    Comma:=ini.ReadBool(SecOption,KeyComma,defComma);
    Second:=ini.ReadBool(SecOption,KeySecond,defSecond);
    Weekday:=ini.ReadBool(SecOption,KeyWeekday,defWeekday);
    WeekdayType:=ini.ReadInteger(SecOption,KeyWeekdayType,defWeekdayType);
    if NOT weekday then
      mnWDNone.checked:=true
    else begin
      case WeekdayType of
        0:mnWDEn3.Checked:=true;
        1:mnWDEn2.Checked:=true;
        2:mnWDKanji.Checked:=true;
      end;
    end;
    case ini.ReadInteger(SecOption,KeyShowMemType,defShowMemType) of
      1 : FShowMemType:=smtMB;
      2 : FShowMemType:=smtGB;
    end;
    case ShowMemType of
      smtKB : mnKB.Checked:=true;
      smtMB : mnMB.Checked:=true;
      smtGB : mnGB.Checked:=true;
    end;
  finally
    ini.free;
  end;
end;

function TAyaClockForm.GetMaxPhysMemStr:string;
var
  ms : TMemoryStatusEx;
begin
  // メモリの1GB Over Check -> 7桁表示で , 有り表示の場合のために事前チェック
  FillChar(ms,sizeof(ms),0);
  ms.dwLength:=sizeof(TMemoryStatusEx);
  GlobalMemoryStatusEx(ms);
  result := IntToStr(ms.ullTotalPhys div MemModifier);
end;

function  TAyaClockForm.MemModifier:int64;
begin
  case ShowMemType of
    smtMB : result:=1024*1024;      // MB
    smtGB : result:=1024*1024*1024; // GB
    else    result:=1024;           // KB
  end;
end;

function  TAyaClockForm.MemUnitString:string;
begin
  case ShowMemType of
    smtMB : result:='MB';
    smtGB : result:='GB';
    else    result:='KB';
  end;
end;

procedure TAyaClockForm.SetupTimeAndMem;
var
  ms : TMemoryStatusEx;
  wc : int64;
begin
  if Weekday then
    DayST.caption:=FormatDateTime('mm/dd',date)+'('+WeekdayStrs[WeekdayType,Zeller]+')'
  else
    DayST.caption:=FormatDateTime('mm/dd',date);
  IF Second THEN
    TimeST.caption:=FormatDateTime('hh:nn:ss',time)
  ELSE
    TimeST.caption:=FormatDateTime('hh:nn',time);
  FillChar(ms,sizeof(ms),0);
  ms.dwLength:=sizeof(TMemoryStatusEx);
  GlobalMemoryStatusEx(ms);
  IF Comma THEN BEGIN
    wc:=ms.ullAvailPhys div MemModifier;
    MemST.caption:=IntToCommaStr(wc,3)+MemUnitString;
  END ELSE
    MemST.caption:=IntToStr(ms.ullAvailPhys div MemModifier)+MemUnitString;
end;

type
  TTrayRects = record
    SrcRect,
    TrayRect : TRect;
    Found : boolean;
  end;
  PTrayRects = ^TTrayRects;

function EnumSTWFunc(_hwnd:HWND; _lParam:LPARAM):BOOL; stdcall;
const
  maxchar = 256;
var
  tr : PTrayRects;
  wr : TRect;
  cn : array[0..maxchar-1] of char;
begin
  if _lparam=0 then
    result:=false
  else begin
    result:=true;
    tr:=PTrayRects(_lParam);
    FillChar(cn,sizeof(cn),0);
    if 0<>GetClassName(_hwnd,@cn[0],maxchar) then begin
      if CompareStr('Shell_SecondaryTrayWnd',string(cn))=0 then begin
        // タスクバーだったのでそれの領域取得
        if GetWindowRect(_hwnd,wr) then begin
          tr.Found:=NOT TRect.Intersect(tr.SrcRect,wr).IsEmpty; // もし空でないなら、それが目的のタスクバー
          if tr.Found then begin
            tr.TrayRect:=wr; // 目的のタスクバーのサイズを格納して終わる
            result:=false;
          end;
        end;
      end;
    end;
  end;
end;

procedure TAyaClockForm.SetPos;
var
  w,h : integer;
  r : TRect;
  bs : TAppBarData;
  mn : TMonitor;
  // SHAppBarMessageを使ってタスクバーの位置情報を取得するのは非常に
  // めんどくさいので、単にタスクバーのサイズから各種情報を取得する。
  // つーか、ABM_QUERYPOSは、アプリが最初に立ち上がったときにあった
  // タスクバーの位置を返す。つまり、その後位置を変えても、変更後の
  // 位置を反映しないなどの不具合が、すくなくとも2000+SP1では在った。
  // →ABM_GETTASKBARPOSを使え！
  procedure GetAppBarRect;
  begin
    //FillChar(bs,sizeof(bs),0);
    //bs.cbSize:=sizeof(bs);
    WITH bs DO BEGIN
      uEdge:=UINT(-1); // ガード
      hWnd:=FindWindow('Shell_TrayWnd',nil); // タスクバーのハンドル
      IF hwnd=0 THEN Exit; // タスクバーのハンドルが取れなかった
      IF NOT GetWindowRect(hWnd,rc) THEN Exit; // サイズがとれなかった
      // タスクバーの位置を判定
      w:=Screen.Width div 2; h:=Screen.height div 2;
      IF rc.right<w THEN  // こうなるのはタスクバーが左にあるときのみ
        uEdge := ABE_LEFT
      ELSE IF rc.left>w THEN // こうなるのはタスクバーが右になるときのみ
        uEdge := ABE_RIGHT
      ELSE IF rc.bottom<h THEN
        uEdge := ABE_TOP
      ELSE
        uEdge := ABE_BOTTOM;
      // タスクバーの位置情報を反映
      CASE uEdge OF
        ABE_BOTTOM:  // 下
          r.bottom:=rc.top;
        ABE_LEFT:    // 左
          r.left:=rc.right;
        ABE_RIGHT:   // 右
          r.right:=rc.left;
        ABE_TOP:     // 上
          r.top:=rc.bottom;
      END;
    END;
  end;
  procedure GetAppBarRect10(AMn:TMonitor);
  var
    tr:TTrayRects;
    i : NativeUInt;
    trgIdx : NativeInt;
  begin
    if AMn=Screen.PrimaryMonitor then
      // Primary Monitorなら従来の処理
      GetAppBarRect
    else begin
      // Secondary Monitor以降の場合
      tr.Found:=false;
      tr.SrcRect:=AMn.BoundsRect;
      EnumWindows(@EnumSTWFunc,LPARAM(@tr)); // EnumWindows APIを呼んでEnumSTWFunc内で判定
      if tr.Found then begin
        w:=AMN.left + AMn.Width div 2; h:=AMn.top + AMn.Height div 2;
        if tr.TrayRect.right<w then
          r.left:=tr.TrayRect.right
        else if tr.TrayRect.left>w then
          r.right:=tr.TrayRect.Left
        else if tr.TrayRect.bottom<h then
          r.top:=tr.TrayRect.Bottom
        else
          r.bottom:=tr.TrayRect.top;
      end;
    end;
  end;
begin
  // 位置調整中は何もしないで抜ける
  if NowMoving then Exit;
  // 画面サイズを取得
  mn:=Screen.MonitorFromWindow(handle);
  r.left:=mn.left; r.right:=mn.Left+mn.Width;
  r.top:=mn.top; r.bottom:=mn.Top+mn.Height;
  // タスクバーの情報を取得
  IF NOT mnIgnoreTB.Checked THEN BEGIN
    if IsWin10OrLater then begin
      // Windows 10以降はWorkAreaRectが当てにならないので……
      GetAppBarRect10(mn);
    end else IF IsWin8OrLater THEN BEGIN
      // Windows 8以降はSecondary以降もTaskBarがある
      r:=mn.WorkareaRect;
    END ELSE BEGIN
      // Windows 7までは従来通りの処理
      IF (mn=Screen.PrimaryMonitor) THEN
        GetAppBarRect;
    END;
  END;
  // 設定
  CASE PosType OF
    1 : // 左上
      BEGIN
        left:=r.Left; top:=r.top;
      END;
    2 : // 左下
      BEGIN
        left:=r.left; top:=r.bottom-Height;
      END;
    3 : // 右上
      BEGIN
        left:=r.right-Width; top:=r.top;
      END;
    4 : // 右下
      BEGIN
        left:=r.right-Width; top:=r.bottom-Height;
      END;
    5 : // 任意の場所
      BEGIN
        IF left<r.left THEN left:=r.left;
        IF (left+width)>r.right THEN left:=r.right-width;
        IF top<r.top THEN top:=r.top;
        IF (top+height)>r.bottom THEN top:=r.bottom-height;
      END;
  END;
end;

procedure TAyaClockForm.ResetPosition(newpos:integer);
var
  ini : TRegIniFile;
begin
  IF (newpos<1) OR (5<newpos) THEN Exit;
  PosType:=newpos;
  SetPos;
  // write reg
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteInteger(SecPosition,KeyType,postype);
    ini.WriteInteger(SecPosition,KeyX,left);
    ini.WriteInteger(SecPosition,KeyY,top);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.Adjust;
var
  c,d : char;
  w,w0,w1,w2,h,cn,i,wk : integer;
  n4,n6 : integer;
  tm : TTextMetric;
begin
  // 各数字の最大幅を計算
  w:=0; d:='0';
  FOR c:='0' TO '9' DO BEGIN
    LB.caption:=c;
    IF LB.width>w THEN BEGIN w:=LB.width; d:=c; END;
  END;
  LB.caption:=d+d+d+d;
  n4:=LB.Width;  // 数字４つの最大幅(MM/DD or hh:mm で使用)
  LB.caption:=d+d+d+d+d+d;
  n6:=LB.Width;  // 数字６つの最大幅(hh:mm:ssで使用)
  cLB.Font:=Font;
  cLB.Font.Style:=[];
  cLB.caption:=d;
  w:=cLB.width;  // 余白の幅(数字の中の最大幅)
  // 高さ
  GetTextMetrics(LB.canvas.handle,tm);
  h:=tm.tmAscent; // tmDecent分はいらない:-
  IF Comma THEN h:=h+tm.tmDescent; // , 表示の時は...
  if Weekday then begin
    // 月日・曜日
    LB.caption:='/()'; w2:=LB.Width;
    wk:=0;
    for i := 0 to 6 do begin
      LB.caption:=WeekdayStrs[weekdaytype,i];
      if wk<LB.width then wk:=LB.Width;
    end;
    DayST.SetBounds(BasePnl.BevelWidth+2,3,wk+w2+n4,h);
  end else begin
    // 月日
    LB.caption:='/';
    DayST.SetBounds(BasePnl.BevelWidth+2,3,LB.Width+n4,h);
  end;
  // 時間
  IF Second THEN BEGIN
    LB.Caption:='::'; w0:=n6+LB.Width;  // hh:mm:ssの長さ
  END ELSE BEGIN
    LB.Caption:=':'; w0:=n4+LB.Width;   // hh:mmの長さ
  END;
  //LB.Caption:=':'; w0:=n4+LB.Width;   // hh:mmの長さ
  TimeST.SetBounds(DayST.Left+DayST.Width+w,3,w0,h);
  // メモリ
  LB.Caption:=MemUnitString;
  IF Comma THEN BEGIN
    // , で区切る場合
    cn := (Length(MaxPhysMemStr)-1) div 3;
    FOR i:=1 TO cn DO LB.Caption:=','+LB.Caption;
  END;
  w1:=Lb.Width; // まずは(あれば),とKB/MBの分の長さ
  LB.Caption:='';
  FOR i:=1 TO Length(MaxPhysMemStr) DO
    LB.Caption:=LB.Caption+d;
  w1:=w1+LB.width; // メモリサイズの桁数分を加える
  MemST.SetBounds(TimeST.Left+TimeST.Width+w,3,w1,h);
  // パネル
  BasePnl.SetBounds(1,1,MemST.Left+MemST.width+2+BasePnl.BevelWidth,h+4+BasePnl.BevelWidth*2);
  // Shape
  Shape1.SetBounds(0,0,BasePnl.Width+2, BasePnl.Height+2);
  // フォーム
  ClientHeight:=Shape1.height;
  ClientWidth:=Shape1.width;
end;

procedure TAyaClockForm.Timer1Timer(Sender: TObject);
var
  n : TDateTime;
  i : integer;
begin
  SetPos; // Screenのサイズ変更に対応
  Inc(qCounter);
  n:=Now;
  i:=StrToInt(FormatDateTime('nn',n))*10 + StrToInt(FormatDateTime('ss',n));
  IF (1000<=(qCounter*Timer1.Interval)) OR (preMinSec<>i) THEN BEGIN
    // 前に更新してから最低限１秒経った or 秒が更新されたなら、実行
    preMinSec:=i;
    qCounter:=0;
    SetupTimeAndMem;
  END;
end;

procedure TAyaClockForm.mnQuitClick(Sender: TObject);
begin
  Close;
end;

procedure TAyaClockForm.mnFontClick(Sender: TObject);
var
  ini : TRegIniFile;
  w : integer;
begin
  NowOp:=TRUE;
  try
    // font
    FontDlg.Font:=Font;
    FontDlg.Font.Size:=OrgFontSize;
    IF FontDlg.Execute THEN BEGIN
      OrgFontSize:=FontDlg.Font.Size;
      Font:=FontDlg.Font;
      Font.Size:=OrgFontSize * PixelsPerInch div DefDPI;
      Adjust;
      ResetPosition(PosType);
      // write reg
      ini:=TRegIniFile.Create(RegRoot);
      try
        ini.WriteString(SecFont,KeyName,Font.Name);
        ini.WriteInteger(SecFont,KeySize,OrgFontSize);
        ini.WriteString(SecFont,KeyColor,ColorToString(Font.Color));
        w:=0;
        IF fsBold in Font.Style THEN w:=w OR feBold;
        IF fsItalic in Font.Style THEN w:=w OR feItalic;
        IF fsUnderLine in Font.Style THEN w:=w OR feUnderLine;
        IF fsStrikeOut in Font.Style THEN w:=w OR feStrikeOut;
        ini.WriteInteger(SecFont,KeyEffect,w);
      finally
        ini.free;
      end;
    END;
  finally
    NowOp:=FALSE;
  end;
end;

procedure TAyaClockForm.mnAboutClick(Sender: TObject);
var
  AboutForm:TAboutForm;
begin
  // about
  NowOp:=TRUE;
  try
    AboutForm:=TAboutForm.Create(self);
    try
      AboutForm.ShowModal;
    finally
      ABoutForm.Free;
    end;
  finally
    NowOp:=FALSE;
  end;
end;

procedure TAyaClockForm.mnPosChangeClick(Sender: TObject);
begin
  //
  WITH (Sender as TMenuItem) DO BEGIN
    Checked:=true;
    ResetPosition(Tag);
  END;
end;

procedure TAyaClockForm.ChangeFormXY(C:TControl; var x,y:integer);
var
  tp : TPoint;
begin
  tp.x:=x; tp.y:=y;
  tp:=C.ClientToScreen(tp);
  x:=tp.x; y:=tp.y;
end;

procedure TAyaClockForm.ACMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  IF (PosType<>5) OR (Button<>mbLeft) THEN Exit;
  //
  NowMoving:=true;
  ChangeFormXY(Sender as TControl,x,y);
  sx:=x; sy:=y;
end;

procedure TAyaClockForm.ACSTMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  IF NOT NowMoving THEN Exit;
  //
  ChangeFormXY(Sender as TControl,x,y);
  SetBounds(left+(x-sx),top+(y-sy),width,height);
  sx:=x; sy:=y;
end;

procedure TAyaClockForm.ACSTMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ini : TRegIniFile;
begin
  IF NOT NowMoving THEN Exit;
  NowMoving:=false;
  //
  if newDPI<>NoRequestDPIChanged then begin
    AdjustForDPIChanged(newDPI);
    newDPI:=NoRequestDPIChanged;
    SetPos;
  end;
  //
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteInteger(SecPosition,KeyX,left);
    ini.WriteInteger(SecPosition,KeyY,Top);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.mnIgnoreTBClick(Sender: TObject);
var
  ini : TRegIniFile;
begin
  mnIgnoreTB.Checked:=NOT mnIgnoreTB.Checked;
  //
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeyIgnoreTaskBar,mnIGnoreTB.Checked);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  x,y:integer;
begin
  IF (KEY=VK_RETURN) AND (Shift=[ssCtrl]) THEN BEGIN
    KEY:=0;
    x:=left+width div 2; y:=top+height div 2;
    SetCursorPos(x,y);
    Pmn.Popup(x,y);
  END;
end;

procedure TAyaClockForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then pmn.Popup(x,y);
end;

procedure TAyaClockForm.mnAdjustTimeClick(Sender: TObject);
var
  cmd : string;
{$IFNDEF WIN64}
  sv : pointer;
  rv : boolean;
{$ENDIF}
  sts : TQuerySeXXXStatus;
  r : DWORD;
  procedure OpenCpl;
  begin
    // コンパネを開く
    ShellExecute(Handle,
                 @cmd[1],
                 'rundll32.exe',
                 'shell32.dll,Control_RunDLL Timedate.cpl',
                 '', SW_SHOW);
  end;
begin
  cmd:='Open';
  // W2KとXPの場合、権限が無い場合はRunAsでコンパネを開く
  if (IsW2K OR IsXP) then begin
    r:=QuerySeXXX(SE_SYSTEMTIME_NAME,sts);
    if (r=NO_ERROR) and (sts=qsxNone) then cmd:='RunAs';
  end;
  // x86_64環境対策
{$IFNDEF WIN64}
  if IsWow64 then begin
    sv:=nil;
    rv:=Wow64DisableWow64FsRedirection(sv);
    try
      OpenCpl;
    finally
      if rv then begin
        if not Wow64RevertWow64FsRedirection(sv) then begin
          r:=GetLastError;
          ShowMessage('!!! panic !!!'+#13#10+
                      'cannot revert WoW64 redirect....'+#13#10+
                      'Error='+IntToStr(r)+#13#10+
                      'AyaClock quit!');
          Close;
        end;
      end;
    end;
  end else
{$ENDIF}
    OpenCpl;
end;

procedure TAyaClockForm.mnAlwaysTopClick(Sender: TObject);
var
  ini : TRegIniFile;
begin
  StayOnTop:=NOT StayOnTop;
  //
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeyAlwaysTop,StayOnTop);
  finally
    ini.free;
  end;
end;


procedure TAyaClockForm.PmnPopup(Sender: TObject);
begin
  // check shield icon
  GetShieldIcon;
end;

procedure TAyaClockForm.TrayIconClick(Sender: TObject);
begin
  PmnPopup(sender);
end;

procedure TAyaClockForm.SetNowOp(ANowOp:boolean);
begin
  IF FNowOp=ANowOp THEN Exit;
  FNowOp:=ANowOp;
  IF FNowOp THEN BEGIN
    mnFont.Enabled:=false;
    mnABout.Enabled:=false;
  END ELSE BEGIN
    mnFont.Enabled:=true;
    mnABout.Enabled:=true;
  END;
end;

function  TAyaClockForm.GetStayOnTop:boolean;
begin
  result:=mnAlwaysTop.Checked;
end;

procedure TAyaClockForm.SetStayOnTop(AValue:boolean);
begin
  IF mnALwaysTop.Checked=AValue THEN Exit;
  //
  mnAlwaysTop.Checked:=AValue;
  IF StayOnTop THEN FormStyle:=fsStayOnTop ELSE FormStyle:=fsNormal;
end;

function  TAyaClockForm.GetComma:boolean;
begin
  result:=mnComma.Checked;
end;

procedure TAyaClockForm.SetComma(AValue:boolean);
var
  ini : TRegIniFile;
begin
  IF Comma=AValue THEN Exit;
  mnComma.Checked:=AValue;
  Adjust;
  ResetPosition(PosType);
  Repaint;
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeyComma,Comma);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.mnCommaClick(Sender: TObject);
begin
  Comma:=NOT Comma;
end;

procedure TAyaClockForm.mnDefaultColorClick(Sender: TObject);
begin
  ColorType:=ctDefault;
end;

procedure TAyaClockForm.mnThemeColorClick(Sender: TObject);
begin
  ColorType:=ctTheme;
end;

function  TAyaClockForm.GetSecond:boolean;
begin
  result:=mnSecond.Checked;
end;

procedure TAyaClockForm.SetSecond(AValue:boolean);
var
  ini : TRegIniFile;
begin
  IF Second=AValue THEN Exit;
  mnSecond.Checked:=AValue;
  Adjust;
  ResetPosition(PosType);
  Repaint;
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeySecond,Second);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.mnSecondClick(Sender: TObject);
begin
  Second:=NOT Second;
end;

procedure TAyaClockForm.mnWeekdayClick(Sender: TObject);
var
  ini : TRegIniFile;
begin
  // guard
  if (sender as TMenuItem).Checked then Exit; // 既にチェックされていたら何もしない
  (sender as TMenuItem).Checked:=true;
  //
  if sender=mnWDNone then begin
    Weekday:=false;
  end else if sender=mnWDEn3 then begin
    Weekday:=true;
    WeekDayType:=0;
  end else if sender=mnWDEn2 then begin
    Weekday:=true;
    WeekDayType:=1;
  end else if sender=mnWDKanji then begin
    Weekday:=true;
    WeekDayType:=2;
  end;
  Adjust;
  ResetPosition(PosType);
  Repaint;
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteBool(SecOption,KeyWeekday,Weekday);
    ini.WriteInteger(SecOption,KeyWeekdayType,WeekdayType);
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.SetShowMemType(AMemType:TShowMemType);
var
  ini : TRegIniFile;
begin
  if ShowMemType=AMemType then exit;
  FShowMemType:=AMemType;
  Adjust;
  ResetPosition(PosType);
  Repaint;
  ini:=TRegIniFile.Create(RegRoot);
  try
    ini.WriteInteger(SecOption,KeyShowMemType,ord(FShowMemType));
  finally
    ini.free;
  end;
end;

procedure TAyaClockForm.mnMemUnitsClick(Sender: TObject);
begin
  if Sender=mnKB then begin
    ShowMemType:=smtKB;
    mnKB.Checked:=true;
  end else if Sender=mnMB then begin
    ShowMemType:=smtMB;
    mnMB.Checked:=true;
  end else if Sender=mnGB then begin
    ShowMemType:=smtGB;
    mnGB.Checked:=true;
  end;
end;

procedure TAyaClockForm.WmQueryEndSession(var msg:TWMQueryEndSession);
begin
  msg.Result:=1;
end;

function TAyaClockForm.GetCurrentDPI:UINT;
var
  ini : TRegIniFile;
  pt : TPoint;
  m : TMonitor;
  w,xdpi,ydpi : UINT;
  _hdc : HDC;
begin
  _HDC:=GetDC(0);
  try
    xdpi:=GetDeviceCaps(_hdc,LOGPIXELSX);
  finally
    ReleaseDC(0,_HDC);
  end;
  if IsWin81OrLater then begin
    ini:=TRegIniFile.Create(RegRoot);
    try
      pt.x:=ini.ReadInteger(SecPosition,KeyX,defX);
      pt.y:=ini.ReadInteger(SecPosition,KeyY,defY);
    finally
      ini.free;
    end;
    m:=Screen.MonitorFromPoint(pt);
    if s_ok=GetDPIForMonitor(m.Handle,MDT_Effective_DPI,w,ydpi) then
      xdpi:=w;
  end;
  dpichecked:=true;
  result:=xdpi;
end;

procedure TAyaClockForm.WmDPIChanged(var msg:TWMDPIChanged);
begin
  if NOT dpichecked then begin
    // このメッセージが届いている時点でWindows 8.1以降
    PixelsPerInch:=GetCurrentDPI;
  end else if NowMoving then begin
    // 移動中なら後で調整
    newDPI:=msg.XDPI;
  end else begin
    // DPI変更されたので対応
    newDPI:=NoRequestDPIChanged;
    if PixelsPerInch<>msg.XDPI then
      AdjustForDPIChanged(msg.XDPI);
  end;
end;

// SetPos前に新しいサイズで位置調整
procedure TAyaClockForm.AdjustForDPIChanged(ADPI:UInt);
var
  svl,svt,svw,svh : integer;
begin
  // 変更前の値を保存
  svl:=Left; svt:=Top; svw:=width; svh:=height;
  // DPIの変更
  PixelsPerInch:=ADPI;
  Font.size:=OrgFontSize * ADPI div DefDPI;
  Adjust;
  // 変更前の位置を見て場所を再調整
  case PosType of
    1: // 左上
      begin
        left:=svl; top:=svt;
      end;
    2: // 左下
      begin
        left:=svl; top:=svt+svh-height;
      end;
    3: // 右上
      begin
        left:=svl+svw-width; top:=svt;
      end;
    4: // 右下
      begin
        left:=svl+svw-width; top:=svt+svh-height;
      end;
    5: // 自由位置
      begin
        left:=svl+(svw div 2)-(width div 2);
        top:=svt+(svh div 2)-(height div 2);
      end;
  end;
end;

end.
