unit privilegesutils;

////////////////////////////////////////////////////////////////
//
// Privilegesׂ̒`yуc[
//
// Copyright (C) 2009 Ayakawa,Marinosuke & MarleySoft
//
// http://homepage1.nifty.com/Ayakawa/
//
// rev  0
// date 2009/07/02
// auth fT
// memo o
//
// rev  1
// date 2009/12/03
// auth fT
// memo QuerySeXXXǉ
//
// rev  2
// date 2011/11/05
// auth fT
// memo ̓wł葱ǉ
//
////////////////////////////////////////////////////////////////

interface

uses
  Winapi.windows;

const
  SE_CREATE_TOKEN_NAME              ='SeCreateTokenPrivilege';
  SE_ASSIGNPRIMARYTOKEN_NAME        ='SeAssignPrimaryTokenPrivilege';
  SE_LOCK_MEMORY_NAME               ='SeLockMemoryPrivilege';
  SE_INCREASE_QUOTA_NAME            ='SeIncreaseQuotaPrivilege';
  SE_UNSOLICITED_INPUT_NAME         ='SeUnsolicitedInputPrivilege';
  SE_MACHINE_ACCOUNT_NAME           ='SeMachineAccountPrivilege';
  SE_TCB_NAME                       ='SeTcbPrivilege';
  SE_SECURITY_NAME                  ='SeSecurityPrivilege';
  SE_TAKE_OWNERSHIP_NAME            ='SeTakeOwnershipPrivilege';
  SE_LOAD_DRIVER_NAME               ='SeLoadDriverPrivilege';
  SE_SYSTEM_PROFILE_NAME            ='SeSystemProfilePrivilege';
  SE_SYSTEMTIME_NAME                ='SeSystemtimePrivilege';
  SE_PROF_SINGLE_PROCESS_NAME       ='SeProfileSingleProcessPrivilege';
  SE_INC_BASE_PRIORITY_NAME         ='SeIncreaseBasePriorityPrivilege';
  SE_CREATE_PAGEFILE_NAME           ='SeCreatePagefilePrivilege';
  SE_CREATE_PERMANENT_NAME          ='SeCreatePermanentPrivilege';
  SE_BACKUP_NAME                    ='SeBackupPrivilege';
  SE_RESTORE_NAME                   ='SeRestorePrivilege';
  SE_SHUTDOWN_NAME                  ='SeShutdownPrivilege';
  SE_DEBUG_NAME                     ='SeDebugPrivilege';
  SE_AUDIT_NAME                     ='SeAuditPrivilege';
  SE_SYSTEM_ENVIRONMENT_NAME        ='SeSystemEnvironmentPrivilege';
  SE_CHANGE_NOTIFY_NAME             ='SeChangeNotifyPrivilege';
  SE_REMOTE_SHUTDOWN_NAME           ='SeRemoteShutdownPrivilege';
  SE_UNDOCK_NAME                    ='SeUndockPrivilege';
  SE_SYNC_AGENT_NAME                ='SeSyncAgentPrivilege';
  SE_ENABLE_DELEGATION_NAME         ='SeEnableDelegationPrivilege';
  SE_MANAGE_VOLUME_NAME             ='SeManageVolumePrivilege';
  SE_IMPERSONATE_NAME               ='SeImpersonatePrivilege';
  SE_CREATE_GLOBAL_NAME             ='SeCreateGlobalPrivilege';
  SE_TRUSTED_CREDMAN_ACCESS_NAME    ='SeTrustedCredManAccessPrivilege';
  SE_RELABEL_NAME                   ='SeRelabelPrivilege';
  SE_INC_WORKING_SET_NAME           ='SeIncreaseWorkingSetPrivilege';
  SE_TIME_ZONE_NAME                 ='SeTimeZonePrivilege';
  SE_CREATE_SYMBOLIC_LINK_NAME      ='SeCreateSymbolicLinkPrivilege';

type
  TQuerySeXXXStatus = (qsxNone,              // ĂȂ
                       qsxDisabled,          // /Lł͂Ȃ
                       qsxEnabled,           // /LɂȂĂ
                       qsxEnabledByDefault); // /defaultŗL

function GetSeXXX(var tpSv:TTokenPrivileges; ATokenStr:string):DWORD;
function SetSeXXX(tpSv:TTokenPrivileges):DWORD;
function QuerySeXXX(ATokenStr:string; var status:TQuerySeXXXStatus):DWORD;

// GetSeXXXspSvɕύXOTokenPrivilegesi[B
// gI疾IFreeMem(pSv)邱ƁBSetSeXXXsł͉ȂB
function GetSeXXXs(var pSv:PTokenPrivileges; ATokenStrs:array of string):DWORD;
function SetSeXXXs(pSv:PTokenPrivileges):DWORD;

implementation

uses
  sysutils;

function QuerySeXXX(ATokenStr:string; var status:TQuerySeXXXStatus):DWORD;
var
  Luid : TLargeInteger;
  hToken : THandle;
  sz : DWORD;
  p : pointer;
  pT : PTokenPrivileges;
  i : integer;
begin
  result:=NO_ERROR;
  status:=qsxNone;
  // ɊւLUID擾
  IF NOT LookupPrivilegeValue(nil,PChar(ATokenStr),Luid) THEN BEGIN
    result:=GetLastError; Exit;
  END;
  // ANZXg[N擾
  IF NOT OpenProcessToken(GetCurrentProcess,TOKEN_QUERY,hToken) THEN BEGIN
    result:=GetLastError; Exit;
  END;
  // ̃`FbN
  try
    sz:=0;
    GetTokenInformation(hToken,TokenPrivileges,nil,0,sz);
    if sz>0 then begin
      try
        p:=AllocMem(sz);
        try
          if GetToKenInformation(hToken,TokenPrivileges,p,sz,sz) then begin
            pT := PTokenPrivileges(p);
            for i := 0 to pT^.PrivilegeCount - 1 do
              if pT^.Privileges[i].Luid=Luid then begin
                // 𔭌
                if (pT^.Privileges[i].Attributes and SE_PRIVILEGE_ENABLED_BY_DEFAULT)<>0 then
                  status:=qsxEnabledByDefault
                else if (pT^.Privileges[i].Attributes and SE_PRIVILEGE_ENABLED)<>0 then
                  status:=qsxEnabled
                else
                  status:=qsxDisabled;
                break;
              end;
          end;
        finally
          FreeMem(p);
        end;
      except
        On EOutOfMemory DO ;
      end;
    end;
  finally
    CloseHandle(hToken);
  end;
end;

function GetSeXXX(var tpSv:TTokenPrivileges; ATokenStr:string):DWORD;
var
  Luid : TLargeInteger;
  tpNew : TTokenPrivileges;
  dwDummy : DWORD;
  hToken : THandle;
begin
  result:=NO_ERROR;
  // ɊւLUID擾
  IF NOT LookupPrivilegeValue(nil,PChar(ATokenStr),Luid) THEN BEGIN
    result:=GetLastError; Exit;
  END;
  // ANZXg[N擾
  IF NOT OpenProcessToken(GetCurrentProcess,TOKEN_WRITE OR TOKEN_QUERY,hToken) THEN BEGIN
    result:=GetLastError; Exit;
  END;
  // Shutdown̕ύXv
  tpNew.PrivilegeCount:=1;
  tpNew.Privileges[0].Luid:=Luid;
  tpNew.Privileges[0].Attributes:=SE_PRIVILEGE_ENABLED;
  IF NOT AdjustTokenPrivileges(hToken,FALSE,tpNew,sizeof(tpSv),tpSv,dwDummy) THEN
    result:=GetLastError;
  // ANZXg[N
  CloseHandle(hToken);
end;

function SetSeXXX(tpSv:TTokenPrivileges):DWORD;
var
  tpDummy : TTokenPrivileges;
  Dummy : DWORD;
  hToken : Thandle;
begin
  result:=NO_ERROR;
  // ANZXg[N擾
  IF NOT OpenProcessToken(GetCurrentProcess,TOKEN_WRITE OR TOKEN_QUERY,hToken) THEN BEGIN
    result:=GetLastError; Exit;
  END;
  // ɖ߂
  IF NOT AdjustTokenPrivileges(hToken,FALSE,tpSv,sizeof(tpDummy),tpDummy,Dummy) THEN
    result:=GetLastError;
  // ANZXg[N
  CloseHandle(hToken);
end;

// ̓̎擾
function GetSeXXXs(var pSv:PTokenPrivileges; ATokenStrs:array of string):DWORD;
var
  Luids : array of TLargeInteger;
  pNew : PTokenPrivileges;
  dwDummy,tpSize : DWORD;
  hToken : THandle;
  i,cnt : integer;
begin
  pSv:=nil; pNew:=nil;
  result:=NO_ERROR;
  cnt:=Length(ATokenStrs);
  if cnt=0 then exit;
  SetLength(Luids,cnt);
  // ɊւLUID擾
  for i:=0 to cnt-1 do begin
    IF NOT LookupPrivilegeValue(nil,PChar(ATokenStrs[i]),Luids[i]) THEN BEGIN
      result:=GetLastError; Exit;
    END;
  end;
  // ANZXg[N擾
  IF NOT OpenProcessToken(GetCurrentProcess,TOKEN_WRITE OR TOKEN_QUERY,hToken) THEN BEGIN
    result:=GetLastError; Exit;
  END;
  // Shutdown̕ύXv
  try
    tpSize:=sizeof(TTokenPrivileges)+sizeof(TLUIDAndAttributes)*(cnt-1);
    GetMem(pNew,tpSize); GetMem(pSv,tpSize);
    pNew^.PrivilegeCount:=cnt;
    for i:=0 to cnt-1 do begin
      pNew^.Privileges[i].Luid:=Luids[i];
      pNew^.Privileges[i].Attributes:=SE_PRIVILEGE_ENABLED;
    end;
    IF NOT AdjustTokenPrivileges(hToken,FALSE,pNew^,tpSize,pSv,dwDummy) THEN begin
      result:=GetLastError;
      FreeMem(pSv); FreeMem(pNew);
    end else
      FreeMem(pNew);
  except
    ON EOutOfMemory DO begin
      result:=ERROR_NOT_ENOUGH_MEMORY;
      if pSv<>nil then FreeMem(pSv);
      if pNew<>nil then FreeMem(pNew);
    end;
  end;
  // ANZXg[N
  CloseHandle(hToken);
end;

function SetSeXXXs(pSv:PTokenPrivileges):DWORD;
var
  tpDummy : TTokenPrivileges;
  Dummy : DWORD;
  hToken : Thandle;
begin
  result:=NO_ERROR;
  // ANZXg[N擾
  IF NOT OpenProcessToken(GetCurrentProcess,TOKEN_WRITE OR TOKEN_QUERY,hToken) THEN BEGIN
    result:=GetLastError; Exit;
  END;
  // ɖ߂
  IF NOT AdjustTokenPrivileges(hToken,FALSE,pSv^,sizeof(tpDummy),tpDummy,Dummy) THEN
    result:=GetLastError;
  // ANZXg[N
  CloseHandle(hToken);
end;


end.
